unit Configurator;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ComCtrls, ExtCtrls,cpl,dialogs;

type
  TPagesDlg = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    PageControl: TPageControl;
    Config: TTabSheet;
    TabSheet3: TTabSheet;
    OKBtn: TButton;
    CancelBtn: TButton;
    HelpBtn: TButton;
    Label1: TLabel;
    Speed: TEdit;
    UpDown1: TUpDown;
    Label2: TLabel;
    Label3: TLabel;
    PollRate: TEdit;
    UpDown2: TUpDown;
    Button1: TButton;
    GamePort: TComboBox;
    Label4: TLabel;
    Image1: TImage;
    Memo1: TMemo;
    Threshold: TEdit;
    UpDown3: TUpDown;
    Label5: TLabel;
    procedure OKBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PagesDlg: TPagesDlg;

implementation

uses emul;

{$R *.DFM}


procedure TPagesDlg.OKBtnClick(Sender: TObject);
begin
if pagecontrol.ActivePage =Config then
   with keeper.j do
   begin
     deactivate;
     Pollrate:=strtoint(self.Pollrate.text);
     NotifyRange:=strtoint(self.speed.text);
     Threshold:=strtoint(self.Threshold.text);
     CalibrateCenter;
     CalibrateUpLeft;
     CalibrateDownRight;
     activate;
   end;
   close;
end;

procedure TPagesDlg.FormShow(Sender: TObject);
begin
 Speed.Text:=inttostr(keeper.j.NotifyRange);
     PollRate.Text:=inttostr(keeper.j.PollRate);
end;

procedure TPagesDlg.Button1Click(Sender: TObject);
var
   joycpl:hmodule; // handle of loaded Applet
   CPlApplet:TCPLAPPLET; // define entry point of joy.cpl
   res:longint;
begin

joycpl:=loadlibrary('joy.cpl');   // map Applet
if joycpl = 0 then
   begin
     joycpl:=loadlibrary('joystick.cpl');
     if joycpl = 0 then
        begin
          messagedlg('Cannot open joystick configurator.'+#10+#13+
                     'Use control panel to calibrate it.',mtError,[mbOk],0);
          exit;
        end;
   end;
@CPlApplet:=getprocaddress(joycpl,'CPlApplet'); // Get entry point
if @CplApplet = nil then
   begin
          messagedlg('Cannot open joystick configurator.'+#10+#13+
                     'Use control panel to calibrate it.',mtError,[mbOk],0);
          exit;
   end;
Keeper.j.enabled:=false;
res:=CPlApplet(self.Handle,CPL_init,0,0); // initialize applet
res:=CPlApplet(self.handle,cpl_dblclk,0,0); // start applet
Keeper.j.enabled:=TRUE;
end;

end.

