unit emul;
{ TmKnob : Marco Caselli's Joystick to mouse
 This component emulate the volume knob you could find on some HiFi devices;
**********************************************************************
* Feel free to use or give away this software as you see fit.        *
* Please leave the credits in place if you alter the source.         *
*                                                                    *
* This software is delivered to you "as is",                         *
* no guarantees of any kind.                                         *
*                                                                    *
* If you find any bugs, please let me know, I will try to fix them.  *
* If you modify the source code, please send me a copy               *
*                                                                    *
* If you like this component,  and also if you dislike it ;), please *
* send me an E-mail with your comment                                *
* Marco Caselli                                                      *
* Web site : http://i.am/pkc                      *
* E-mail   : mcaselli@iname.com                                      *
*                                                                    *
* Note: the TTrayicon and Tjoystick component ARE NOT MINE. I've     *
* found this two in a developer CD and I don't know authors.         * 
* I have also slightly modified their code to best fit my need       *
**********************************************************************
*** Sorry for my bad english ...............
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Tjoystk, StdCtrls, TrayIcon, Menus;

type
  TKeeper = class(TForm)
    j: TJoystick;
    yj: TLabel;
    xj: TLabel;
    Tray: TTrayIcon;
    IcoList: TImageList;
    Pop: TPopupMenu;
    Close1: TMenuItem;
    Config1: TMenuItem;
    procedure jJoyMove(Sender: TObject; var X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure TrayClick(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Config1Click(Sender: TObject);
    procedure jButton1(Sender: TObject; Pushed: Boolean);
    procedure jButton2(Sender: TObject; Pushed: Boolean);
    procedure TrayDblClick(Sender: TObject);
  private
    { Private declarations }
    Emulating:boolean;
    fButton  :Word;
  public
    OscillCut:byte;
    { Public declarations }
  end;

var
  Keeper: TKeeper;

implementation

uses Configurator;

{$R *.DFM}

procedure TKeeper.jJoyMove(Sender: TObject; var X, Y: Integer);
begin

if abs(x) < OscillCut then x:=0;
if abs(y) < OscillCut then y:=0;
if ((x<>0) or (y<>0)) and emulating then begin
   mouse_event(MOUSEEVENTF_MOVE,x,-y,0,0);
end;
end;

procedure TKeeper.FormCreate(Sender: TObject);
begin
emulating:=true;
OscillCut:=2;
IcoList.geticon(0,tray.icon);
j.activate;
j.enabled:=true;
j.CalibrateCenter;
j.CalibrateUpLeft;
j.CalibrateDownRight;
end;

procedure TKeeper.TrayClick(Sender: TObject);
var w:Ticon;
begin
w:=Ticon.Create;
if emulating then
   begin
     emulating:=false;
     IcoList.geticon(1,w);
     tray.icon:=w;
   end
else
   begin
     emulating:=true;
     IcoList.geticon(0,w);
     tray.icon:=w;
   end;
w.Free;
end;

procedure TKeeper.Close1Click(Sender: TObject);
begin
application.terminate;
end;

procedure TKeeper.Config1Click(Sender: TObject);
begin
config1.enabled:=false;
Pagesdlg.show;
config1.enabled:=true;
end;

procedure TKeeper.jButton1(Sender: TObject; Pushed: Boolean);
begin
  if emulating then
    begin
     if pushed = true  then
        mouse_event(MOUSEEVENTF_leftdown,0,0,0,0)
     else
        mouse_event(MOUSEEVENTF_leftup,0,0,0,0);
    end;
end;

procedure TKeeper.jButton2(Sender: TObject; Pushed: Boolean);
begin
  if emulating then
    begin
      if pushed = true  then
         mouse_event(MOUSEEVENTF_rightdown,0,0,0,0)
      else
         mouse_event(MOUSEEVENTF_rightup,0,0,0,0);
    end;
end;
procedure TKeeper.TrayDblClick(Sender: TObject);
begin
config1click(sender);
end;

end.
